#include <stdio.h>
#include <math.h>
/* quoz_polinomi.c : file sorgente di un programma che esegue
                     la divisione tra polinomi a coefficienti interi. */
/* ### */
/* La prossima definizione consente di cambiare facilmente il grado
   massimo che puo' assumere i polinomi che vengono rappresentati
   dal programma. */
#define GRADOMAX 10
/* Definizione dei prototipi delle funzioni */
void aggiungi_primo_polinomio_al_secondo(int grado_pol1, int vet_pol1[],
					 int *grado_pol2, int vet_pol2[]);
void divisione_polinomiale(int grado_pol, int vet_pol[], int grado_divis,
			   int vet_divis[], int *grado_quoz, int vet_quoz[],
			   int *grado_resto, int vet_resto[]);
void prodotto_per_potenza_x(int grado_pol, int vet_pol[], int exp_x,
			    int *grado_ris, int vet_ris[]);
void prodotto_per_scalare(int *grado_pol, int vet_pol[], int coef);
void stampa_polinomio(int grado_pol, int vet_pol[]);
/* ### */
int main()
{
  int i, grado_p, vet_p[GRADOMAX+1], grado_d, vet_d[GRADOMAX+1];
  int grado_q, vet_q[GRADOMAX+1], grado_r, vet_r[GRADOMAX+1];
  int grado_a, vet_a[GRADOMAX+1], exp_x;
  int coef;
  /* Input della variabile grado_p (cioe' il grado del polinomio P(x)) */ 


  if(grado_p == -1) {
    printf("Quando il grado e' negativo s'intende che il polinomio sia = 0\n");
  }
  else {
    printf("  -- Inizio inserimento dei coefficienti del polinomio P(x) --\n");
    /* Eseguiamo il ciclo di istruzioni seguente per i compreso tra 0 e
       grado_p-1 */
    
    {
      /* Input di vet_p[i] (cioe' del coefficiente relativo al termine
	 x^i) */


    }
    do {
      printf("Coefficiente intero relativo al termine x^%d ?\n",grado_p);
      printf("(deve essere diverso da 0, e' il termine di grado massimo!)\n");

    } while(vet_p[grado_p]==0);
    printf("  -- Fine inserimento dei coefficienti del polinomio P(x) --\n");
  }
  printf("  Prova di stampa del polinomio P(x):\n");
  printf("P(x) = ");

  printf("\n\n");
  /* Attenzione!!!
     Se non si vuole appesantire troppo la parte di programma scritta
     nel main e l'output del programma stesso, si possono togliere
     tutte le istruzioni a cominciare da quella che segue fino
     all'input del grado del polinomio D(x).
     Tutte queste istruzioni sono state scritte per agevolare la
     fase di test del programma passo per passo */
  do {
    printf("Inserire un coefficiente intero (deve essere >=0 e <=%d) per\n",
	   GRADOMAX-grado_p);
    printf("effettuare la moltiplicazione per una potenza di x:\n");

  } while(exp_x<0 || exp_x>GRADOMAX-grado_p);
  printf("  Prova di moltiplicazione per una potenza di x:\n");

  printf("A(x) = x^%d * P(x) = ", exp_x);

  printf("Inserire un coefficiente intero per effettuare\n");
  printf("la moltiplicazione per uno scalare:\n");

  printf("  Prova di moltiplicazione per scalare:\n");

  printf("A(x) = %d * x^%d * P(x) = ", coef, exp_x);

  /* Input della variabile grado_d (cioe' il grado del polinomio D(x)) */ 


  if(grado_d == -1) {
    printf("Quando il grado e' negativo s'intende che il polinomio sia = 0\n");
  }
  else {
    printf("  -- Inizio inserimento dei coefficienti del polinomio D(x) --\n");
    /* Eseguiamo il ciclo di istruzioni seguente per i compreso tra 0 e
       grado_d-1 */

    {
      /* Input di vet_d[i] (cioe' del coefficiente relativo al termine
	 x^i) */


    }
    printf("Il coefficiente intero relativo al termine x^%d ", grado_d);
    printf("e' automaticamente\ndefinito uguale a 1, perche' questo e' ");
    printf("il caso in cui la divisione\ntra polinomi a coefficienti interi ");
    printf("da sempre quoziente e resto\nche sono ancora ");
    printf("polinomi a coefficienti interi\n");

    printf("  -- Fine inserimento dei coefficienti del polinomio D(x) --\n");
  }
  printf("  Prova di stampa del polinomio D(x):\n");
  printf("D(x) = ");

  /* Attenzione!!!
     Se non si vuole appesantire troppo la parte di programma scritta
     nel main e l'output del programma stesso, si possono togliere
     tutte le istruzioni a cominciare da quella che segue fino
     all'inizio della prova di divisione polinomiale.
     Tutte queste istruzioni sono state scritte per agevolare la
     fase di test del programma passo per passo */
  printf("  Prova di somma di un primo polinomio a un secondo:\n");

  printf("A(x) + D(x) = ");

  printf("  Prova di divisione polinomiale:\n");

  printf("P(x) = D(x) * Q(x) + R(x) ,\n");
  printf("  dove\n");
  printf("P(x) = ");

  printf("D(x) = ");

  printf("Q(x) = ");

  printf("R(x) = ");

  exit(0);
}
/* ### */
void aggiungi_primo_polinomio_al_secondo(grado_pol1, vet_pol1,
					 grado_pol2, vet_pol2)
     int grado_pol1, vet_pol1[], *grado_pol2, vet_pol2[];
     /* Nota: per semplicita' si assume che quando la funzione
	      viene chiamata il grado del secondo polinomio
	      e' maggiore o uguale a quello del primo */
{
  int i;
  /* Effettuiamo un test per verificare se il coefficiente del
     primo polinomio e' maggiore di quello del secondo ... */

  {
    /* ... Questa function non contempla questo caso, che potrebbe
       generare degli errori.
       Allora stampiamo un messaggio di errore e usciamo dalla
       function */


  }
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     grado_pol1 */

  {
    /* Al coefficiente del termine di grado i del secondo polinomio
       deve essere aggiunto il coefficiente del termine dello stesso
       grado del primo polinomio */

  }
  /* Aggiornamento del grado del secondo polinomio:
     eseguiamo il ciclo di istruzioni seguenti per i che va dal grado
     del secondo polinomio fino a 0 (a ritroso) */

  {
    /* Effettuiamo un test per verificare se il coefficiente del
       termine di grado i del secondo polinomio e' uguale a zero ... */

    {
      /* ... Allora il grado del secondo polinomio deve essere
	 decrementato di 1 */

    }

    {
      /* ... Altrimenti usciamo dal ciclo sul contatore i con
	 un'istruzione break  */

    }
  }
}
/* ### */
void divisione_polinomiale(grado_pol, vet_pol, grado_divis, vet_divis,
			   grado_quoz, vet_quoz, grado_resto, vet_resto)
     int grado_pol, vet_pol[], grado_divis, vet_divis[];
     int *grado_quoz, vet_quoz[], *grado_resto, vet_resto[];
{
  int i, grado_add, vet_add[GRADOMAX];
  /* Uguagliamo il resto al polinomio dividendo (il primo nella lista
     degli argomenti);
     per prima cosa uguagliamo il grado dei polinomi ... */

  /* ... poi eseguiamo il ciclo di istruzioni seguenti per i che va da
     0 a grado_pol */

  {
    /* Uguagliamo il coefficiente del termine di grado i del polinomio
       resto a quello corrispondente del polinomio dividendo */

  }
  /* Effettuiamo un test per verificare se il grado del polinomio
     divisore e' maggiore di quello del polinomio dividendo ... */

  {
    /* ... Allora poniamo il polinomio quoziente uguale a 0 (basta
       porre il grado pel polinomio quoziente uguale a -1) */

    /* A questo punto la divisione e' gia' terminata: usciamo dalla
       function */

  }
  /* Poniamo il grado del polinomio quoziente uguale al grado
     del polinomio dividendo meno quello del polinomio divisore */

  /* Eseguiamo il ciclo di istruzioni seguenti per i che va dal grado
     del polinomio quoziente fino a 0 (a ritroso) */

  {
    /* Poniamo (temporaneamente) il polinomio addendo uguale
       al polinomio divisore moltiplicato per x elevato alla i */

    /* Poniamo il coefficiente del termine di grado i del polinomio
       quoziente uguale al coefficiente del termine di grado i + il
       grado del polinomio divisore */

    /* Moltiplichiamo il polinomio addendo per meno il coefficiente
       del termine grado i del polinomio quoziente */

    /* Aggiungiamo il polinomio addendo al polinomio resto */

  }
}
/* ### */
void prodotto_per_potenza_x(grado_pol, vet_pol, exp_x, grado_ris, vet_ris)
     int grado_pol, vet_pol[], exp_x, *grado_ris, vet_ris[];
{
  int i;
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     grado_pol */

  {
    /* Il coefficiente del termine di grado i+exp_x del polinomio
       risultato e' uguale al coefficiente del termine di grado i
       del polinomio rappresentato dal vettore vet_pol */

  }
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     exp_x-1 */

  {
    /* Azzeriamo il coefficiente del termine di grado i del polinomio
       risultato */

  }
  /* Calcolo del grado del polinomio risultato:
     effettuiamo un test per verificare se grado_pol e' minore
     di zero ... */

  {
    /* ... Allora il polinomio rappresentato dal vettore vet_pol e'
       uguale a 0, quindi sara' zero anche il polinomio risultato,
       dunque poniamo il grado del polinomio risultato uguale a -1 */

  }

  {
    /* ... Altrimenti il grado del polinomio risultato sara' uguale
       alla somma del grado del polinomio rappresentato dal vettore
       vet_pol piu' l'esponente di x */

  }
}
/* ### */
void prodotto_per_scalare(grado_pol, vet_pol, coef)
     int *grado_pol, vet_pol[], coef;
{
  int i;
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     grado_pol */

  {
    /* Il coefficiente del termine di grado i del polinomio deve
       essere moltiplicato per il numero coef  */

  }
  /* Aggiornamento del grado del polinomio risultato:
     effettuiamo un test per verificare se coef e' uguale a zero ... */

  {
    /* ... Allora il polinomio e' diventato uguale a zero, quindi
       poniamo il suo grado uguale a -1 */

  }
}
/* ### */
void stampa_polinomio(grado_pol, vet_pol)
     int grado_pol, vet_pol[];
{
  int i;
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da grado_p
     fino a 0 (a ritroso) */

  {
    /* Effettuiamo un test per verificare se P(x) il coefficiente del
       termine di grado i e' diverso da zero, altrimenti non dobbiamo
       fare nulla e decrementiamo i */

    {
      /* Effettuiamo un test per verificare se i e' minore di grado_pol
	 ... */

      {
	/* ... Allora se il coefficiente del termine di grado i e'
	   positivo dobbiamo stampare " +" ... */


	/* ... Altrimenti stampiamo solo uno spazio*/


      }
      /* Effettuiamo un test per verificare se il grado i e' uguale
	 a zero ... */

      {
	/* ... Allora stampiamo il coefficiente e nient'altro */

      }
      /* ... Altrimenti se i e' diverso da zero ...*/

      {
	/* stampiamo il coefficiente (seguito da un simbolo *) solo se
	   il coefficiente e' diverso da 1 */


	/* Adesso stampiamo la potenza i-esima di x */

      }
    }
  }
  /* Osservazione: se grado_pol < 1, nel ciclo di istruzioni
     precedenti sul contatore i non e' stato stampato niente.
     Effettuiamo un test per verificare se grado_pol e' minore
     di 0 ...*/

  {
    /* ... Allora stampiamo semplicemente uno 0 */

  }
  /* Stampiamo un ritorno a capo riga */

}
